<?php
   $verify_token = "devcorner";
    $hub_verify_token = null;
    if(isset($_REQUEST['hub_challenge'])) {
        $challenge = $_REQUEST['hub_challenge'];
        $hub_verify_token = $_REQUEST['hub_verify_token'];
    }
    if ($hub_verify_token === $verify_token) {
        echo $challenge;
    }


$access_token = "twój kod weryfikacyjny tutaj"; // dodaj swój kod weryfikacyjny

$input = json_decode(file_get_contents('php://input'), true);
$sender = $input['entry'][0]['messaging'][0]['sender']['id'];
$message = $input['entry'][0]['messaging'][0]['message']['text'];
$message_to_reply = '';


$user_info_url = "https://graph.facebook.com/v2.6/".$sender."?fields=first_name,last_name,profile_pic,locale,timezone,gender&access_token=".$access_token;
$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, $user_info_url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

$result = curl_exec($ch);

curl_close ($ch);

$user = json_decode($result);

if(preg_match('[cześć|dzień dobry|witam]', strtolower($message))) {
    $array = ['Dzień dobry', 'Witam', 'Cześć', 'Hej'];
    $message_to_reply = $array[array_rand($array)]." ".$user->first_name;

    $jsonData = '{
        "recipient":{
            "id":"'.$sender.'"
        },
        "message":{
            "text":"'.$message_to_reply.'"
        }
    }';
}
elseif(preg_match('[pogoda w|prognoza pogody w]', strtolower($message))) {

  // pobranie nazwy miasta z wiadomości
  $get_city = explode(' w ', $message);
  $city = $get_city[1];

  $weather_url = "http://api.openweathermap.org/data/2.5/weather?q=".$city."&units=metric&lang=pl&appid=twoj_appid"; // dodaj swój apikey

  function get_http_response_code($url) {
      $headers = get_headers($url);
      return substr($headers[0], 9, 3);
  }

  if(get_http_response_code($weather_url) == "200") {

    $weather_json = file_get_contents($weather_url);
    $weather = json_decode($weather_json, true);

    // pobranie aktualnej temperatury
    $temp = $weather['main']['temp'];
    // pobranie zachmurzenia w procentach
    $clouds = $weather['clouds']['all'];
    // pobranie prędkości wiatru w m/s
    $wind = $weather['wind']['speed'];

    $message_to_reply = "Temperatura w ".$city." wynosi ".$temp. " stopni Celcjusza. ".
    "Niebo jest zachmurzone w ".$clouds."%. Wiatr wieje z prędkością ".$wind." m/s.";

  } else {
    $message_to_reply = 'Nie mogliśmy pobrać pogody. Wpisz "Pogoda w [nazwa miasta]".';
  }


  $jsonData = '{
      "recipient":{
          "id":"'.$sender.'"
      },
      "message":{
          "text":"'.$message_to_reply.'"
      }
  }';

  }

  elseif(preg_match('[regulamin]', strtolower($message))) {

    $jsonData = '{
        "recipient":{
            "id":"'.$sender.'"
        },
        "message":{
        "attachment":{
          "type":"file",
          "payload":{
            "url":"https://devcorner.pl/wp-content/uploads/2017/02/regulamin.pdf"
          }
        }
      }
    }';

  }

  elseif(preg_match('[zdjęcie|obrazek]', strtolower($message))) {

    $jsonData = '{
        "recipient":{
            "id":"'.$sender.'"
        },
        "message":{
            "attachment":{
              "type":"image",
              "payload":{
                "url":"https://devcorner.pl/wp-content/uploads/2017/02/messenger-840x500.jpg"
              }
            }
        }
    }';

  }

  elseif(preg_match('[opcje|co mogę zrobić]', strtolower($message))) {

    $jsonData = '{
        "recipient":{
            "id":"'.$sender.'"
        },
        "message":{
        "attachment":{
          "type":"template",
          "payload":{
            "template_type":"button",
            "text":"Co chcesz zrobić?",
            "buttons":[
              {
                "type":"web_url",
                "url":"https://devcorner.pl/zbudowac-chatbota-dla-messengera-php-2-nawiazanie-komunikacji/",
                "title":"Najnowszy wpis"
              },
              {
                "type":"web_url",
                "url":"https://devcorner.pl",
                "title":"Strona główna"
              },
            ]
          }
        }
      }
    }';

  }

  else {
      $message_to_reply = 'Nie rozumiem. Co masz na myśli?';
  }


$url = 'https://graph.facebook.com/v2.6/me/messages?access_token='.$access_token;
$ch = curl_init($url);



// informujemy cURL, że chcemy przesłać żądanie POST.
curl_setopt($ch, CURLOPT_POST, 1);

// dodajemy zakodowany JSON string do POST.
curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
// ustawiamy content type na application/json
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));

// wykonaj żądanie
if(!empty($input['entry'][0]['messaging'][0]['message'])){
    $result = curl_exec($ch);
}




?>
